<?php
/*---------------------------------------------------------------------
/   This script will tell you how to install SourceGuardian loaders   /
/                  http://www.sourceguardian.com/                     /
---------------------------------------------------------------------*/
?>
<BODY bgcolor="white">
<BASEFONT face="Tahoma, Sans-serif, Arial, Helvetica, Verdana">
<H2>How to install <A HREF="http://www.sourceguardian.com/">SourceGuardian</A> loaders</H2>
<?php

function ondebug(){
  echo "Your PHP engine is compiled in DEBUG mode.<BR>";
  echo "This mode was designed for debug PHP engine but not for production servers.<BR>";
  echo "You should install normal PHP engine which is available from ";
  echo '<A HREF="http://www.php.net/">http://www.php.net/</A>.';
}
function nortl($reason){
  echo '<H3>Run-time loading</H3>';
  echo 'Run-time loading is not possible because of <B>'.$reason.'</B>.<BR>';
  echo 'Use server-wide setup or re-configure PHP engine.';
}
function rtl($pack,$ixed_dir){
  echo '<H3>Run-time loading</H3>';
  echo '<OL>';
  echo '<LI>Download '.$pack.'</LI>';
  echo '<LI>Extract it to folder <B>'.$ixed_dir.'</B></LI>';
  echo '</OL>';
}
function sws($pack,$ext_dir,$php_ini,$loader){
  echo '<H3>Server-wide setup</H3>';
  echo '<OL>';
  echo '<LI>Download '.$pack.'</LI>';
  echo '<LI>Extract it to folder <B>'.$ext_dir.'</B></LI>';
  echo '<LI>Edit PHP.INI file (located at <B>'.$php_ini.'</B>) and add following line:<BR>';
  echo '<B>extension='.$loader.'</B></LI>';
  echo '</OL>';
}
function unknown_os(){
  echo 'Probably this operating system is not yet supported by SourceGuardian.<BR>';
  echo 'Please visit support section at <A HREF="http://www.sourceguardian.com/">SourceGuardian home</A>.';
}

  $nl='<BR>';

  if (function_exists("ixed_pass")){
    echo "SourceGuardian loaders are already installed.";
    exit();
  }

  $uname=php_uname();
  $os=substr($uname,0,strpos($uname,' '));  
  $os_alias=strtolower(substr($uname,0,3));
  
  $zts=0;
  $php_ini='';
  $safe_mode=ini_get('safe_mode');
  $cur_dir=dirname(__FILE__);
  $debug=0;
  $php_ver=phpversion();
  $php_mver=substr($php_ver,0,3);
  $sapi=php_sapi_name();

  ob_start();
  phpinfo(INFO_GENERAL);
  $php_info=ob_get_contents();
  ob_end_clean();

  $info=split("\n",$php_info);
  while (list($key,$val)=each($info)){
    if (eregi('command',$val)) continue;
    if (eregi('thread safety.*(enabled|yes)',$val)) $zts=1;
    if (eregi('debug.*(enabled|yes)',$val)) $debug=1;
    if (eregi('configuration file.*(</B></td><TD ALIGN="left">| => |v">)([^ <]*)(.*</td.*)?',
      $val,$match)) $php_ini=$match[2];
  }

  if ($debug) {
    ondebug();
    exit();
  }

  $dl=1;
  $dl_reason='unknown';
  if ($zts){
    if ((substr($sapi,0,3)!='cgi') and ($sapi!="cli") and (substr($sapi,0,5)!='embed')) {
      $dl=0;
      $dl_reason='thread safety';
    }
  }
  
  if ($safe_mode) {
    $dl=0;
    $dl_reason='safe mode';
  }

  $pack='<A HREF="http://www.sourceguardian.com/ixeds/ixed.'.$os_alias.'.zip">ixed.'.$os_alias.'.zip</A>';
  $loader='ixed.'.$os_alias.'.'.$php_ver.'.pxp';
  $ext_dir=realpath(ini_get('extension_dir'));
  
  if ($os_alias=='win') {
    sws($pack,$ext_dir,$php_ini,$loader);
    if ($dl){
      $ixed_dir=$cur_dir.'\\ixed\\';
      rtl($pack,$ixed_dir);
    } else nortl($dl_reason);
  } else if ($os_alias=='lin') {
    if ($zts) $loader='ixed.lin.'.$php_mver.'.ts.pxp';
    sws($pack,$ext_dir,$php_ini,$loader);
    if ($dl){
      $ixed_dir=$cur_dir.'/ixed/';
      rtl($pack,$ixed_dir);
    } else nortl($dl_reason);
  } else if ($os_alias=='fre') {
    if ($zts) $loader='ixed.lin.'.$php_mver.'.ts.pxp';
    sws($pack,$ext_dir,$php_ini,$loader);
    if ($dl){
      $ixed_dir=$cur_dir.'/ixed/';
      rtl($pack,$ixed_dir);
    } else nortl($dl_reason);
  } else {
    unknown_os();
  };
/*
  echo "<HR>";

  echo "OS: $os".$nl;
  echo "PHP version: $php_ver".$nl;
  echo "PHP.INI: $php_ini".$nl;
  echo "cur_dir: $cur_dir".$nl;
  echo "ZTS: $zts".$nl;
  echo "DEBUG: $debug".$nl;
  echo "safe mode: $safe_mode".$nl;
  echo "SAPI: $sapi".$nl;
*/
?>
